// Created by Beycan Kahraman...

#include <iostream>
#include <math.h>

#define 	NOKTA_SAYISI 	30

using namespace std;

bool gercek_degerler = false;

//	dx/dy = -y
float fonksiyon(float x, float y){
	return  -y;
}

// y(0) = 1 verildigine gore y(0,1) = ?
void RueKunta4( float f(float x, float y), float X = 0, float Y = 1 )
{
	float 	a = 1.0f / 6, 	d = a;
	float 	b = 1.0f / 3, 	c = b;
	float 	m = 1.0f / 2, 	n = m;
	float 	p = 1.0f;
	float 	h = 0.1f;
	float   k[4], y[NOKTA_SAYISI], x[NOKTA_SAYISI];
	
	y[0] = Y;
	x[0] = X;
	
	cout << "  ARANAN RK-4 NOKTALARI             k0        k1        k2        k3" << endl;
	cout << "-------------------------       ----------------------------------------" << endl;
	
	for( int i = 0; i < NOKTA_SAYISI; i++ )
	{
		k[0] = h*f(x[i], y[i]);
		k[1] = h*f(x[i] + h/2, y[i] + k[0]/2);
		k[2] = h*f(x[i] + h/2, y[i] + k[1]/2);
		k[3] = h*f(x[i] + h, y[i] + k[2]);
		
		if( i < NOKTA_SAYISI - 1 )
			x[i+1] = x[i] + h;
			
		y[i+1] = y[i] + ( k[0] + 2*k[1] + 2*k[2] + k[3] ) / 6;
		
		cout << " " << i+1 << ".\t( " << x[i] << ",\t" << y[i] << " )\t"
			 << k[0] << " " << k[1] << " " << k[2] << " " << k[3] << endl;
		if(gercek_degerler) // Buras sadece dx/dy = -y denklemi icin dogru deger verir
			cout << "\t" << "( " << x[i] << ",\t" << exp(-x[i]) << " )" << endl;
	}
	cout << endl;
}

int main(void)
{
    cout << "-------------------------------------------------------------------" << endl <<
    		" Bu program dy/dx = -y denkleminde y(0) = 1 noktasindan baslayarak" << endl <<
    		"     RK-4 yontemi ile y(i) yaklasik degerlerini bulmaktadir..." << endl <<
			"-------------------------------------------------------------------" << endl << endl;
    
	cout << "Gercek Degerleri de Gormek Ister misiniz? ( 1 / 0 ) : ";
	cin >> gercek_degerler;
	cout << endl;
    RueKunta4(fonksiyon, 0, 1);
    system("PAUSE");
    return 1;
}
